  function [res,sol] = BiCG (A, rhs, x0, m, tol) 
%%--------------------------------------------------
% function [res,sol] = BiCG (A, rhs, x0, m, tol) 
% x0  = initial guess on entry -- 
% rhs = rhs, m = number of steps 
% m   = max number of steps
% tol = tolerance
% res = residuals.. 
% sol = app sol on return 
%%--------------------------------------------------
 sol    = x0; 
 r      = rhs - A * sol;
 rz     = r;
 p      = r ; 
 pz     = p;  
 ro1    = r' * rz; 
 res(1) = sqrt(ro1);  
 tol1   = tol*res(1) ; 
 for j=1:m 
    ro  = ro1; 
    ap  = A * p; 
    alp = ro / ( pz'*ap );   %% !! check div by 0
    sol = sol + alp * p;
    r   = r - alp * ap; 
    rz  = rz - alp*A'*pz;
    ro1 = rz'*r;    
    rsn = norm(r); res(j+1) = rsn; 
    if (rsn < tol1) 
     break
    end
    bet = ro1 / ro ;        %% !! check div by 0
    p   = r + bet * p; 
    pz  = rz + bet * pz; 
 end

         
