%% ---------- define a finite difference matrix 
%% ---------- with a zero convection term (A=A')
A = fd3d(25, 25, 1, 0.0, 0.0, 0., 0);
%% ---------- dimension of A 
n = size(A,1);
%% ---------- right-hand side
b = A*ones(n,1);
%%---------- call sdescent 
[x, r1] = steep(A, b, zeros(n,1), 200); 
%%---------- call MR 
[x, r2] = mr(A, b, zeros(n,1), 200) ;
%%---------- call rn descent
[x, r3] = rndescent(A,b, zeros(n,1), 200) ;
%%---------- plot 3 residual curves..  
semilogy([1:length(r1)],r1,'k-',[1:length(r2)],r2,'b--', ...
[1:length(r3)],r3,'r-.','linewidth',2);
legend('Steepest descent','Min-Res','ResNormDescent') 
xlabel(' iterations') 
ylabel(' res. norms') 
