%% ---------- define a finite difference matrix 
%% ---------- with a zero convection term (A=A')
A = fd3d(25, 25, 1, 0.050, 0.01, 0, 0.1);
%% ---------- dimension of A 
n = size(A,1);
%% ---------- right-hand side
b = A*ones(n,1);
%%---------- call sdescent 
[r1, x] = fom(A, b, zeros(n,1), 100,1.e-05); 
%%---------- call MR 
[r2, x] = gmres0(A, b, zeros(n,1), 100, 1.e-05, 100); 
%%---------- call rn descent
[r3, x] = BiCG(A, b, zeros(n,1), 100,1.e-05); 
%%---------- plot 3 residual curves..  
semilogy([1:length(r1)],r1,'k-',[1:length(r2)],r2,'b--', ...
[1:length(r3)],r3,'r-.','linewidth',2);
legend('FOM','GMRES','BiCG','location','SW') 
xlabel(' iterations') 
ylabel(' res. norms') 

