%%-------------------------------------------------
%% generate a "block " finite difference matrix -- using fd3dB
%%-------------------------------------------------
%Bx = [3 1 -1; 1 3 -1; 0.5 1 3];
%Bz = 100*ones(3,3);
% A = fd3d(8,8,3,Bx,Bx,Bz) ;  
A = fd3d(20, 20, 5, 0.1, -0.2, 0.1, 0.0);

n = size(A,1);

spy(A) 
title([' block elliptic matrix of size  n = ', num2str(n)]) 
disp('pausing -- push any key to continue ') 
%%pause
close 
%%-------------------------------------------------
%% create artificial rhs
rhs = A * ([1:n]') ; 
%% random initial guess
sol0 = rand(n,1); 
%%    S O R / S S O R 
%%
% construct SOR preconditioner 
 L = tril(A); D = diag(A); U = triu(A);
 SOR.L = L; 
 SOR.D = D; 
 SOR.U = U;
 SOR.kiter = 4;
%--------------------------------------------------- 
% ready to call fgmres
 disp(' solution with SOR prec') 
 tic;
 [sol,res1,its] = fgmres(A, SOR,'precLDU', rhs, sol0);
 ts = toc ;
 disp(' ** done ** ') 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%   ILU 
%%
%% construct I L U (0) preconditioner 
%%%
 [L, U] = iluk(A,0) ;
 ILU = struct('L',L,'U',U) ;
 tic
 [sol,res2,its] = fgmres(A, ILU,'precLU', rhs, sol0);
 tk0 = toc;
 disp(' ** done ** ') 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% construct I L U (1) preconditioner 
%%%
 [L, U] = iluk(A,1) ;
 ILU.L = L; ILU.U = U; 
 tic ;
 [sol,res3,its] = fgmres(A, ILU,'precLU', rhs, sol0);
 tk1 = toc;
 disp(' ** done ** ') 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% call ILU factorization from matlab -- store result
% in struct PRE 
%
 disp(' solution with ILUT-GMRES') 
 [L, U] = luinc(A, 0.001);
 ILU.L = L; ILU.U = U;
 tic;
[sol,res4,its] = fgmres(A, ILU,'precLU', rhs, sol0);
 tt = toc;

 fprintf(1,' \n tsor = %d  \n tilu0 = %d \n tilu1 = %d \n tilut = %d\n', ...
  ts, tk0, tk1, tt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

semilogy(res1);

semilogy(res1,'m--','marker','+','LineWidth',2,'color','k')
     hold on
semilogy(res2,'g-.','marker','v','LineWidth',2,'color','g')

semilogy(res3,'b-','marker','d','LineWidth',2,'color','b')

semilogy(res4,'r-','marker','o','LineWidth',2,'color','b')
legend('SOR(4)','ILU(0)','ILU(1)','ilut')
xlabel(' iterations') 
ylabel(' res. norms') 
     hold off 
