function [x, nrmHist] = mr(A, b, x, nsteps) 
% function [x,r] = mr(A,x,b, nsteps) 
% nsteps of minimal residual method
% A = matrix  
% x = initial guess on entry -- app sol on return 
% b = rhs, m = number of steps --
% 
 r = b - A * x;
 nrmHist(1) = norm(r); 
%%
 for i=1:nsteps
	 ar  = A * r; 
	 alp = (ar'*r) / ( ar' * ar);
	 x   = x + alp * r;
	 r   = r - alp* ar;
         nrmHist(i+1) = norm(r);  
 end 
          
