
function [x,res] = rndescent(A, b, x, nsteps, tol) 
%% steepest descent
%% 
if (nargin < 5)
     tol = 0.0;
 end
%% function [x,res] = rndescent(A, b, nsteps, tol, x) 
 r = b - A * x; 
 res0 = norm(r);
 res(1) = res0;
for i=1:nsteps
 d  = A'*r;
 ad = A*d;
 alpha = (d'*d) / (ad'*ad);
 x = x + alpha*d;
 r = r - alpha*ad;
 rho = norm(r) ;
 res(i+1)= rho; 
 if( rho < tol* res0) 
    break
 end
end
